<?php
declare(strict_types=1);

namespace Catequil\Db\Type;

use Doctrine\DBAL\Platforms\AbstractPlatform;
use Doctrine\DBAL\Types\DateImmutableType;

/**
 * Class DateImmutableKeyType
 *
 * @package Catequil\Db\Type
 * @author Danijel Fabijan <hipnaba@gmail.com>
 * @link https://bitbucket.org/oktan-nautika/catequil-db
 */
final class DateImmutableKeyType extends DateImmutableType
{
    const TYPE_NAME = 'date_immutable_key';

    public function getName(): string
    {
        return self::TYPE_NAME;
    }

    public function convertToPHPValue($value, AbstractPlatform $platform)
    {
        $value = parent::convertToPHPValue($value, $platform);

        if (!$value !== null) {
            $value = DateImmutableKey::fromDateTimeImmutable($value);
        }

        return $value;
    }
}